
#ifndef _ETHERNET_H_
#define _ETHERNET_H_

#include "commdef.h"
#include "interface.h"

#ifdef _WIN32
#include "Winsock2.h"
#endif


#ifdef _WIN32
class ARCLIB_API EthernetInterface : public ArcInterface
#else
class EthernetInterface : public ArcInterface
#endif
{
public:		
	EthernetInterface();	
	~EthernetInterface();
	bool init(const char *szIPAddr, short nPort = 7890);
	int send(const char *outBuf, int outLen);	
	int recv(char *inBuf, int inLen);		
	int syncSend(const char *outBuf, int outLen, char *inBuf, int inLen );
	void setTimeOut(int nSec);
	int	getMTU();	

// helper functions
public:
	void *getDeviceHandle();
	SOCKET getSocket();

private:
	int	 WaitForReply(SOCKET s, long time_sec, long time_usec);
	SOCKET m_socket;
#ifdef _WIN32
	CRITICAL_SECTION m_cs;
	void requirelock()
	{
		EnterCriticalSection(&m_cs);
	}
	void releaselock()
	{
		LeaveCriticalSection(&m_cs);
	}
#elif defined(__linux__) || defined(__FreeBSD__) || defined(__solaris__) || defined(__APPLE__)
	
#endif
	struct	sockaddr_in agentaddr;
	struct  sockaddr_in manager_addr;
	int m_nTimeout;
};

#endif

